
_buzzer:

;Voltage_source_with_MCP4921.c,43 :: 		void buzzer() {  // the buzzer sounds every time that any key is pressed
;Voltage_source_with_MCP4921.c,44 :: 		PORTC.b1 = 1;
	IN         R27, PORTC+0
	SBR        R27, 2
	OUT        PORTC+0, R27
;Voltage_source_with_MCP4921.c,45 :: 		delay_ms(Tone);
	LDI        R18, 7
	LDI        R17, 23
	LDI        R16, 107
L_buzzer0:
	DEC        R16
	BRNE       L_buzzer0
	DEC        R17
	BRNE       L_buzzer0
	DEC        R18
	BRNE       L_buzzer0
	NOP
;Voltage_source_with_MCP4921.c,46 :: 		PORTC.b1 = 0;
	IN         R27, PORTC+0
	CBR        R27, 2
	OUT        PORTC+0, R27
;Voltage_source_with_MCP4921.c,47 :: 		delay_ms(Tone);
	LDI        R18, 7
	LDI        R17, 23
	LDI        R16, 107
L_buzzer2:
	DEC        R16
	BRNE       L_buzzer2
	DEC        R17
	BRNE       L_buzzer2
	DEC        R18
	BRNE       L_buzzer2
	NOP
;Voltage_source_with_MCP4921.c,48 :: 		}
L_end_buzzer:
	RET
; end of _buzzer

_DAC_Output:

;Voltage_source_with_MCP4921.c,50 :: 		void DAC_Output(unsigned int valueDAC) {
;Voltage_source_with_MCP4921.c,53 :: 		Chip_Select = 0;                        // Select DAC chip
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;Voltage_source_with_MCP4921.c,56 :: 		volt = (valueDAC >> 8) & 0x0F;          // Store valueDAC[11..8] to temp[3..0]
	MOV        R16, R3
	LDI        R17, 0
	ANDI       R16, 15
;Voltage_source_with_MCP4921.c,57 :: 		volt |= 0x30;                           // Define DAC setting, see MCP4921 datasheet
	ORI        R16, 48
;Voltage_source_with_MCP4921.c,58 :: 		SPI1_Write(volt);                       // Send high byte via SPI
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _SPI1_Write+0
	POP        R2
	POP        R3
;Voltage_source_with_MCP4921.c,62 :: 		SPI1_Write(volt);                       // Send low byte via SPI
	CALL       _SPI1_Write+0
;Voltage_source_with_MCP4921.c,64 :: 		Chip_Select = 1;                        // Deselect DAC chip
	IN         R27, PORTB0_bit+0
	SBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;Voltage_source_with_MCP4921.c,65 :: 		}
L_end_DAC_Output:
	RET
; end of _DAC_Output

_DIG_OR_DEC:

;Voltage_source_with_MCP4921.c,68 :: 		DIG_OR_DEC() {  // seelect digital mode or decimal mode
;Voltage_source_with_MCP4921.c,69 :: 		buzzer();
	PUSH       R2
	PUSH       R3
	CALL       _buzzer+0
;Voltage_source_with_MCP4921.c,70 :: 		if(aux==3) Vint = voltio;
	LDS        R16, _aux+0
	CPI        R16, 3
	BREQ       L__DIG_OR_DEC53
	JMP        L_DIG_OR_DEC4
L__DIG_OR_DEC53:
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	STS        _Vint+0, R16
	STS        _Vint+1, R17
	STS        _Vint+2, R18
	STS        _Vint+3, R19
	JMP        L_DIG_OR_DEC5
L_DIG_OR_DEC4:
;Voltage_source_with_MCP4921.c,71 :: 		else       Vint = value;
	LDS        R16, _value+0
	LDS        R17, _value+1
	LDS        R18, _value+2
	LDS        R19, _value+3
	CALL       _float_fpint+0
	STS        _Vint+0, R16
	STS        _Vint+1, R17
	STS        _Vint+2, R18
	STS        _Vint+3, R19
L_DIG_OR_DEC5:
;Voltage_source_with_MCP4921.c,73 :: 		for(retardo=retardo; retardo<=Vint; retardo++){  //
L_DIG_OR_DEC6:
	LDS        R20, _retardo+0
	LDS        R21, _retardo+1
	LDS        R22, _retardo+2
	LDS        R23, _retardo+3
	LDS        R16, _Vint+0
	LDS        R17, _Vint+1
	LDS        R18, _Vint+2
	LDS        R19, _Vint+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRGE       L__DIG_OR_DEC54
	JMP        L_DIG_OR_DEC7
L__DIG_OR_DEC54:
;Voltage_source_with_MCP4921.c,74 :: 		DAC_Output(retardo);                   // Send value to DAC chip
	LDS        R2, _retardo+0
	LDS        R3, _retardo+1
	CALL       _DAC_Output+0
;Voltage_source_with_MCP4921.c,75 :: 		Delay_ms(20);                         // Slow down key repeat pace
	LDI        R17, 208
	LDI        R16, 202
L_DIG_OR_DEC9:
	DEC        R16
	BRNE       L_DIG_OR_DEC9
	DEC        R17
	BRNE       L_DIG_OR_DEC9
	NOP
;Voltage_source_with_MCP4921.c,73 :: 		for(retardo=retardo; retardo<=Vint; retardo++){  //
	LDS        R16, _retardo+0
	LDS        R17, _retardo+1
	LDS        R18, _retardo+2
	LDS        R19, _retardo+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _retardo+0, R16
	STS        _retardo+1, R17
	STS        _retardo+2, R18
	STS        _retardo+3, R19
;Voltage_source_with_MCP4921.c,76 :: 		}
	JMP        L_DIG_OR_DEC6
L_DIG_OR_DEC7:
;Voltage_source_with_MCP4921.c,77 :: 		for(retardo=retardo; retardo>=Vint; retardo--){
L_DIG_OR_DEC11:
	LDS        R20, _retardo+0
	LDS        R21, _retardo+1
	LDS        R22, _retardo+2
	LDS        R23, _retardo+3
	LDS        R16, _Vint+0
	LDS        R17, _Vint+1
	LDS        R18, _Vint+2
	LDS        R19, _Vint+3
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRGE       L__DIG_OR_DEC55
	JMP        L_DIG_OR_DEC12
L__DIG_OR_DEC55:
;Voltage_source_with_MCP4921.c,78 :: 		DAC_Output(retardo);                   // Send value to DAC chip
	LDS        R2, _retardo+0
	LDS        R3, _retardo+1
	CALL       _DAC_Output+0
;Voltage_source_with_MCP4921.c,79 :: 		Delay_ms(20);                         // Slow down key repeat pace
	LDI        R17, 208
	LDI        R16, 202
L_DIG_OR_DEC14:
	DEC        R16
	BRNE       L_DIG_OR_DEC14
	DEC        R17
	BRNE       L_DIG_OR_DEC14
	NOP
;Voltage_source_with_MCP4921.c,77 :: 		for(retardo=retardo; retardo>=Vint; retardo--){
	LDS        R16, _retardo+0
	LDS        R17, _retardo+1
	LDS        R18, _retardo+2
	LDS        R19, _retardo+3
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	STS        _retardo+0, R16
	STS        _retardo+1, R17
	STS        _retardo+2, R18
	STS        _retardo+3, R19
;Voltage_source_with_MCP4921.c,80 :: 		}
	JMP        L_DIG_OR_DEC11
L_DIG_OR_DEC12:
;Voltage_source_with_MCP4921.c,81 :: 		}
L_end_DIG_OR_DEC:
	POP        R3
	POP        R2
	RET
; end of _DIG_OR_DEC

_print1:

;Voltage_source_with_MCP4921.c,85 :: 		void print1(){
;Voltage_source_with_MCP4921.c,87 :: 		text = "DEC";
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, #lo_addr(?lstr1_Voltage_source_with_MCP4921+0)
	STS        _text+0, R27
	LDI        R27, hi_addr(?lstr1_Voltage_source_with_MCP4921+0)
	STS        _text+1, R27
;Voltage_source_with_MCP4921.c,88 :: 		Lcd_Out(2,1,text);
	LDS        R4, _text+0
	LDS        R5, _text+1
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Voltage_source_with_MCP4921.c,90 :: 		ch = voltio/1000;
	LDI        R20, 232
	LDI        R21, 3
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
;Voltage_source_with_MCP4921.c,91 :: 		Lcd_Chr(2,5,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 5
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;Voltage_source_with_MCP4921.c,92 :: 		ch = (voltio/ 100 )% 10;
	LDI        R20, 100
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;Voltage_source_with_MCP4921.c,93 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;Voltage_source_with_MCP4921.c,94 :: 		Lcd_Chr(2,7,'.');
	LDI        R27, 46
	MOV        R4, R27
	LDI        R27, 7
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;Voltage_source_with_MCP4921.c,95 :: 		ch = (voltio / 10 )% 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;Voltage_source_with_MCP4921.c,96 :: 		Lcd_Chr(2,8,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 8
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;Voltage_source_with_MCP4921.c,97 :: 		ch = voltio % 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;Voltage_source_with_MCP4921.c,98 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;Voltage_source_with_MCP4921.c,100 :: 		}
L_end_print1:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _print1

_print2:

;Voltage_source_with_MCP4921.c,102 :: 		void print2(){
;Voltage_source_with_MCP4921.c,104 :: 		text = "DIG";
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, #lo_addr(?lstr2_Voltage_source_with_MCP4921+0)
	STS        _text+0, R27
	LDI        R27, hi_addr(?lstr2_Voltage_source_with_MCP4921+0)
	STS        _text+1, R27
;Voltage_source_with_MCP4921.c,105 :: 		Lcd_Out(2,1,text);
	LDS        R4, _text+0
	LDS        R5, _text+1
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Voltage_source_with_MCP4921.c,107 :: 		ch = voltio/1000;
	LDI        R20, 232
	LDI        R21, 3
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
;Voltage_source_with_MCP4921.c,108 :: 		Lcd_Chr(2,5,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 5
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;Voltage_source_with_MCP4921.c,109 :: 		ch = (voltio/ 100 )% 10;
	LDI        R20, 100
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;Voltage_source_with_MCP4921.c,110 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;Voltage_source_with_MCP4921.c,111 :: 		ch = (voltio / 10 )% 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;Voltage_source_with_MCP4921.c,112 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;Voltage_source_with_MCP4921.c,113 :: 		ch = voltio % 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;Voltage_source_with_MCP4921.c,114 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;Voltage_source_with_MCP4921.c,115 :: 		Lcd_Chr(2,9,' ');
	LDI        R27, 32
	MOV        R4, R27
	LDI        R27, 9
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;Voltage_source_with_MCP4921.c,117 :: 		}
L_end_print2:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _print2

_Voltage:

;Voltage_source_with_MCP4921.c,119 :: 		void Voltage() {
;Voltage_source_with_MCP4921.c,121 :: 		buzzer();
	CALL       _buzzer+0
;Voltage_source_with_MCP4921.c,123 :: 		if(aux==3) {
	LDS        R16, _aux+0
	CPI        R16, 3
	BREQ       L__Voltage59
	JMP        L_Voltage16
L__Voltage59:
;Voltage_source_with_MCP4921.c,124 :: 		Voltio=(10*Voltio) + contador;
	LDI        R16, 10
	LDI        R17, 0
	LDI        R18, 0
	LDI        R19, 0
	LDS        R20, _Voltio+0
	LDS        R21, _Voltio+1
	LDS        R22, _Voltio+2
	LDS        R23, _Voltio+3
	CALL       _HWMul_32x32+0
	LDS        R20, _contador+0
	LDI        R21, 0
	SBRC       R20, 7
	LDI        R21, 255
	MOV        R22, R21
	MOV        R23, R21
	ADD        R20, R16
	ADC        R21, R17
	ADC        R22, R18
	ADC        R23, R19
	STS        _Voltio+0, R20
	STS        _Voltio+1, R21
	STS        _Voltio+2, R22
	STS        _Voltio+3, R23
;Voltage_source_with_MCP4921.c,125 :: 		if(Voltio>4095) Voltio=contador;
	LDI        R16, 255
	LDI        R17, 15
	LDI        R18, 0
	LDI        R19, 0
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__Voltage60
	JMP        L_Voltage17
L__Voltage60:
	LDS        R16, _contador+0
	STS        _Voltio+0, R16
	LDI        R27, 0
	SBRC       R16, 7
	LDI        R27, 255
	STS        _Voltio+1, R27
	STS        _Voltio+2, R27
	STS        _Voltio+3, R27
L_Voltage17:
;Voltage_source_with_MCP4921.c,126 :: 		print2();
	CALL       _print2+0
;Voltage_source_with_MCP4921.c,127 :: 		}
L_Voltage16:
;Voltage_source_with_MCP4921.c,128 :: 		if(aux==0) {
	LDS        R16, _aux+0
	CPI        R16, 0
	BREQ       L__Voltage61
	JMP        L_Voltage18
L__Voltage61:
;Voltage_source_with_MCP4921.c,129 :: 		Voltio=(10*Voltio) + contador;
	LDI        R16, 10
	LDI        R17, 0
	LDI        R18, 0
	LDI        R19, 0
	LDS        R20, _Voltio+0
	LDS        R21, _Voltio+1
	LDS        R22, _Voltio+2
	LDS        R23, _Voltio+3
	CALL       _HWMul_32x32+0
	LDS        R20, _contador+0
	LDI        R21, 0
	SBRC       R20, 7
	LDI        R21, 255
	MOV        R22, R21
	MOV        R23, R21
	ADD        R20, R16
	ADC        R21, R17
	ADC        R22, R18
	ADC        R23, R19
	STS        _Voltio+0, R20
	STS        _Voltio+1, R21
	STS        _Voltio+2, R22
	STS        _Voltio+3, R23
;Voltage_source_with_MCP4921.c,130 :: 		if(Voltio>1630) Voltio=contador;
	LDI        R16, 94
	LDI        R17, 6
	LDI        R18, 0
	LDI        R19, 0
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__Voltage62
	JMP        L_Voltage19
L__Voltage62:
	LDS        R16, _contador+0
	STS        _Voltio+0, R16
	LDI        R27, 0
	SBRC       R16, 7
	LDI        R27, 255
	STS        _Voltio+1, R27
	STS        _Voltio+2, R27
	STS        _Voltio+3, R27
L_Voltage19:
;Voltage_source_with_MCP4921.c,131 :: 		print1();
	CALL       _print1+0
;Voltage_source_with_MCP4921.c,132 :: 		}
L_Voltage18:
;Voltage_source_with_MCP4921.c,133 :: 		if(aux==1) {
	LDS        R16, _aux+0
	CPI        R16, 1
	BREQ       L__Voltage63
	JMP        L_Voltage20
L__Voltage63:
;Voltage_source_with_MCP4921.c,134 :: 		Voltio=Voltio-100;
	LDS        R20, _Voltio+0
	LDS        R21, _Voltio+1
	LDS        R22, _Voltio+2
	LDS        R23, _Voltio+3
	SUBI       R20, 100
	SBCI       R21, 0
	SBCI       R22, 0
	SBCI       R23, 0
	STS        _Voltio+0, R20
	STS        _Voltio+1, R21
	STS        _Voltio+2, R22
	STS        _Voltio+3, R23
;Voltage_source_with_MCP4921.c,135 :: 		if(Voltio<0) Voltio=0;
	LDI        R16, 0
	LDI        R17, 0
	LDI        R18, 0
	LDI        R19, 0
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLT       L__Voltage64
	JMP        L_Voltage21
L__Voltage64:
	LDI        R27, 0
	STS        _Voltio+0, R27
	STS        _Voltio+1, R27
	STS        _Voltio+2, R27
	STS        _Voltio+3, R27
L_Voltage21:
;Voltage_source_with_MCP4921.c,136 :: 		print1();
	CALL       _print1+0
;Voltage_source_with_MCP4921.c,137 :: 		}
L_Voltage20:
;Voltage_source_with_MCP4921.c,138 :: 		if(aux==2) {
	LDS        R16, _aux+0
	CPI        R16, 2
	BREQ       L__Voltage65
	JMP        L_Voltage22
L__Voltage65:
;Voltage_source_with_MCP4921.c,139 :: 		Voltio=Voltio+100;
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	MOVW       R20, R16
	MOVW       R22, R18
	SUBI       R20, 156
	SBCI       R21, 255
	SBCI       R22, 255
	SBCI       R23, 255
	STS        _Voltio+0, R20
	STS        _Voltio+1, R21
	STS        _Voltio+2, R22
	STS        _Voltio+3, R23
;Voltage_source_with_MCP4921.c,140 :: 		if(Voltio>1630) Voltio=0;
	LDI        R16, 94
	LDI        R17, 6
	LDI        R18, 0
	LDI        R19, 0
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__Voltage66
	JMP        L_Voltage23
L__Voltage66:
	LDI        R27, 0
	STS        _Voltio+0, R27
	STS        _Voltio+1, R27
	STS        _Voltio+2, R27
	STS        _Voltio+3, R27
L_Voltage23:
;Voltage_source_with_MCP4921.c,141 :: 		print1();
	CALL       _print1+0
;Voltage_source_with_MCP4921.c,142 :: 		}
L_Voltage22:
;Voltage_source_with_MCP4921.c,143 :: 		value=Voltio/0.398046; // resolution =1000*(vrf/4095)
	LDS        R16, _Voltio+0
	LDS        R17, _Voltio+1
	LDS        R18, _Voltio+2
	LDS        R19, _Voltio+3
	CALL       _float_slong2fp+0
	LDI        R20, 175
	LDI        R21, 204
	LDI        R22, 203
	LDI        R23, 62
	CALL       _float_fpdiv1+0
	STS        _value+0, R16
	STS        _value+1, R17
	STS        _value+2, R18
	STS        _value+3, R19
;Voltage_source_with_MCP4921.c,144 :: 		}
L_end_Voltage:
	RET
; end of _Voltage

_set_up:

;Voltage_source_with_MCP4921.c,146 :: 		void set_up()
;Voltage_source_with_MCP4921.c,148 :: 		DDRD = 0xF0;
	PUSH       R2
	LDI        R27, 240
	OUT        DDRD+0, R27
;Voltage_source_with_MCP4921.c,149 :: 		PORTD = 0x0F;
	LDI        R27, 15
	OUT        PORTD+0, R27
;Voltage_source_with_MCP4921.c,150 :: 		DDC1_bit=1;
	IN         R27, DDC1_bit+0
	SBR        R27, BitMask(DDC1_bit+0)
	OUT        DDC1_bit+0, R27
;Voltage_source_with_MCP4921.c,151 :: 		PORTC.b1 = 0;
	IN         R27, PORTC+0
	CBR        R27, 2
	OUT        PORTC+0, R27
;Voltage_source_with_MCP4921.c,152 :: 		Chip_Select = 1;              // Deselect DAC
	IN         R27, PORTB0_bit+0
	SBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;Voltage_source_with_MCP4921.c,153 :: 		Chip_Select_Direction = 1;   // Set CS# pin as Output
	IN         R27, DDB0_bit+0
	SBR        R27, BitMask(DDB0_bit+0)
	OUT        DDB0_bit+0, R27
;Voltage_source_with_MCP4921.c,154 :: 		SPI1_Init();                 // Initialize SPI1 module
	CALL       _SPI1_Init+0
;Voltage_source_with_MCP4921.c,155 :: 		Lcd_Init();                  // Initialize LCD
	CALL       _Lcd_Init+0
;Voltage_source_with_MCP4921.c,156 :: 		Lcd_Cmd(_LCD_CLEAR);        //  Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Voltage_source_with_MCP4921.c,157 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);   //  Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Voltage_source_with_MCP4921.c,158 :: 		}
L_end_set_up:
	POP        R2
	RET
; end of _set_up

_Main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;Voltage_source_with_MCP4921.c,159 :: 		void Main()
;Voltage_source_with_MCP4921.c,161 :: 		set_up();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _set_up+0
;Voltage_source_with_MCP4921.c,162 :: 		text = "Voltaje_INT:";
	LDI        R27, #lo_addr(?lstr3_Voltage_source_with_MCP4921+0)
	STS        _text+0, R27
	LDI        R27, hi_addr(?lstr3_Voltage_source_with_MCP4921+0)
	STS        _text+1, R27
;Voltage_source_with_MCP4921.c,163 :: 		Lcd_Out(1,2,text);
	LDS        R4, _text+0
	LDS        R5, _text+1
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Voltage_source_with_MCP4921.c,164 :: 		buzzer();
	CALL       _buzzer+0
;Voltage_source_with_MCP4921.c,166 :: 		while (1) //loop key check forever
L_Main24:
;Voltage_source_with_MCP4921.c,172 :: 		PORTD = 0xEF;   //1110 1111
	LDI        R27, 239
	OUT        PORTD+0, R27
;Voltage_source_with_MCP4921.c,173 :: 		Delay_ms(50);
	LDI        R18, 3
	LDI        R17, 8
	LDI        R16, 120
L_Main26:
	DEC        R16
	BRNE       L_Main26
	DEC        R17
	BRNE       L_Main26
	DEC        R18
	BRNE       L_Main26
;Voltage_source_with_MCP4921.c,174 :: 		if (!(PIND & 0x01))  contador=7, Voltage();
	IN         R16, PIND+0
	SBRC       R16, 0
	JMP        L_Main28
	LDI        R27, 7
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main28:
;Voltage_source_with_MCP4921.c,175 :: 		if (!(PIND & 0x02))  contador=4, Voltage();
	IN         R16, PIND+0
	SBRC       R16, 1
	JMP        L_Main29
	LDI        R27, 4
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main29:
;Voltage_source_with_MCP4921.c,176 :: 		if (!(PIND & 0x04))  contador=1, Voltage();
	IN         R16, PIND+0
	SBRC       R16, 2
	JMP        L_Main30
	LDI        R27, 1
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main30:
;Voltage_source_with_MCP4921.c,177 :: 		if (!(PIND & 0x08))  aux=3,      Voltage();
	IN         R16, PIND+0
	SBRC       R16, 3
	JMP        L_Main31
	LDI        R27, 3
	STS        _aux+0, R27
	CALL       _Voltage+0
L_Main31:
;Voltage_source_with_MCP4921.c,180 :: 		PORTD =0xDF;   //1101 1111;
	LDI        R27, 223
	OUT        PORTD+0, R27
;Voltage_source_with_MCP4921.c,181 :: 		Delay_ms(50);
	LDI        R18, 3
	LDI        R17, 8
	LDI        R16, 120
L_Main32:
	DEC        R16
	BRNE       L_Main32
	DEC        R17
	BRNE       L_Main32
	DEC        R18
	BRNE       L_Main32
;Voltage_source_with_MCP4921.c,182 :: 		if (!(PIND & 0x01))  contador=8,  Voltage();
	IN         R16, PIND+0
	SBRC       R16, 0
	JMP        L_Main34
	LDI        R27, 8
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main34:
;Voltage_source_with_MCP4921.c,183 :: 		if (!(PIND & 0x02))  contador=5,  Voltage();
	IN         R16, PIND+0
	SBRC       R16, 1
	JMP        L_Main35
	LDI        R27, 5
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main35:
;Voltage_source_with_MCP4921.c,184 :: 		if (!(PIND & 0x04))  contador=2,  Voltage();
	IN         R16, PIND+0
	SBRC       R16, 2
	JMP        L_Main36
	LDI        R27, 2
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main36:
;Voltage_source_with_MCP4921.c,185 :: 		if (!(PIND & 0x08))  contador=0,  Voltage();
	IN         R16, PIND+0
	SBRC       R16, 3
	JMP        L_Main37
	LDI        R27, 0
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main37:
;Voltage_source_with_MCP4921.c,188 :: 		PORTD = 0xBF;   //1011 1111;
	LDI        R27, 191
	OUT        PORTD+0, R27
;Voltage_source_with_MCP4921.c,189 :: 		Delay_ms(50);
	LDI        R18, 3
	LDI        R17, 8
	LDI        R16, 120
L_Main38:
	DEC        R16
	BRNE       L_Main38
	DEC        R17
	BRNE       L_Main38
	DEC        R18
	BRNE       L_Main38
;Voltage_source_with_MCP4921.c,190 :: 		if (!(PIND & 0x01))  contador=9,  Voltage();
	IN         R16, PIND+0
	SBRC       R16, 0
	JMP        L_Main40
	LDI        R27, 9
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main40:
;Voltage_source_with_MCP4921.c,191 :: 		if (!(PIND & 0x02))  contador=6,  Voltage();
	IN         R16, PIND+0
	SBRC       R16, 1
	JMP        L_Main41
	LDI        R27, 6
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main41:
;Voltage_source_with_MCP4921.c,192 :: 		if (!(PIND & 0x04))  contador=3,  Voltage();
	IN         R16, PIND+0
	SBRC       R16, 2
	JMP        L_Main42
	LDI        R27, 3
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main42:
;Voltage_source_with_MCP4921.c,193 :: 		if (!(PIND & 0x08))  DIG_OR_DEC(); //(=)
	IN         R16, PIND+0
	SBRC       R16, 3
	JMP        L_Main43
	CALL       _DIG_OR_DEC+0
L_Main43:
;Voltage_source_with_MCP4921.c,196 :: 		PORTD = 0x7F;    //0111 1111;
	LDI        R27, 127
	OUT        PORTD+0, R27
;Voltage_source_with_MCP4921.c,197 :: 		Delay_ms(50);
	LDI        R18, 3
	LDI        R17, 8
	LDI        R16, 120
L_Main44:
	DEC        R16
	BRNE       L_Main44
	DEC        R17
	BRNE       L_Main44
	DEC        R18
	BRNE       L_Main44
;Voltage_source_with_MCP4921.c,198 :: 		if (!(PIND & 0x01)) contador=0, Voltio=0, Voltage(); //('/')
	IN         R16, PIND+0
	SBRC       R16, 0
	JMP        L_Main46
	LDI        R27, 0
	STS        _contador+0, R27
	LDI        R27, 0
	STS        _Voltio+0, R27
	STS        _Voltio+1, R27
	STS        _Voltio+2, R27
	STS        _Voltio+3, R27
	CALL       _Voltage+0
L_Main46:
;Voltage_source_with_MCP4921.c,199 :: 		if (!(PIND & 0x02)) aux=0, contador=0, Voltio=0, Voltage();//(X)
	IN         R16, PIND+0
	SBRC       R16, 1
	JMP        L_Main47
	LDI        R27, 0
	STS        _aux+0, R27
	LDI        R27, 0
	STS        _contador+0, R27
	LDI        R27, 0
	STS        _Voltio+0, R27
	STS        _Voltio+1, R27
	STS        _Voltio+2, R27
	STS        _Voltio+3, R27
	CALL       _Voltage+0
L_Main47:
;Voltage_source_with_MCP4921.c,200 :: 		if (!(PIND & 0x04)) aux=1, contador=0, Voltage(); //(-)
	IN         R16, PIND+0
	SBRC       R16, 2
	JMP        L_Main48
	LDI        R27, 1
	STS        _aux+0, R27
	LDI        R27, 0
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main48:
;Voltage_source_with_MCP4921.c,201 :: 		if (!(PIND & 0x08)) aux=2, contador=0, Voltage(); //(+)
	IN         R16, PIND+0
	SBRC       R16, 3
	JMP        L_Main49
	LDI        R27, 2
	STS        _aux+0, R27
	LDI        R27, 0
	STS        _contador+0, R27
	CALL       _Voltage+0
L_Main49:
;Voltage_source_with_MCP4921.c,202 :: 		}
	JMP        L_Main24
;Voltage_source_with_MCP4921.c,203 :: 		}
L_end_Main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__Main_end_loop:
	JMP        L__Main_end_loop
; end of _Main
