//**********Source_linear_MCP4921********//
//******************************************************************************
//***   Pic16f887 4Mhz  DAC : MCP4921                                        ***
//******************************************************************************
#define Tone 100
/////////DAC module connections/////////////////////////////////////////////////
sbit Chip_Select at RC0_bit;
sbit Chip_Select_Direction at TRISC0_bit;
////////////keypad_4x3//////////////////////////////////////////////////////////
extern sfr char keypadPort;
char  keypadPort at PORTB;
//////////////LCD_declarations//////////////////////////////////////////////////
sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;
/////////////Global_variables///////////////////////////////////////////////////
char *text, kp=0;
int short contador=0;
long voltaje=0, retardo=0;
float volt;
///////////////Configuration////////////////////////////////////////////////////
void Set_up() {

  ANSEL = 0;
  ANSELH = 0;
  C1ON_bit = 0;    // Analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  TRISD0_bit=0;
  TRISD1_bit=0;
  Keypad_Init();
  Lcd_Init();
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Cmd(_LCD_CURSOR_OFF);
  Chip_Select = 1;                       // Deselect DAC
  Chip_Select_Direction = 0;             // Set CS# pin as Output
  SPI1_Init();                           // Initialize SPI module
  RD0_bit=0;
  RD1_bit=0;
  text = "Voltaje_pedido:";
  Lcd_Out(1,1,text);
}
//////the buzzer is activated every time that the keypad is pressed/////////////
void buzzer() {
 RD1_bit=1;
 delay_ms(Tone);
 RD1_bit=0;
 delay_ms(Tone);
}
//////////////////////DAC_configuration/////////////////////////////////////////
//********* DAC increments (0..4095) --> output voltage (0..Vref)
void DAC_Output(unsigned int valueDAC) {
  char temp;

  Chip_Select = 0;                       // Select DAC chip

  // Send High Byte
  temp = (valueDAC >> 8) & 0x0F;         // Store valueDAC[11..8] to temp[3..0]
  temp |= 0x30;                     // Define DAC setting, see MCP4921 datasheet
  SPI1_Write(temp);                 // Send high byte via SPI

  // Send Low Byte
  temp = valueDAC;                       // Store valueDAC[7..0] to temp[7..0]
  SPI1_Write(temp);                      // Send low byte via SPI

  Chip_Select = 1;                       // Deselect DAC chip
}
////////////////////////////////////////////////////////////////////////////////
void Voltage() {

    unsigned char ch ;
 // Write result in ASCII format
    ch = voltaje/1000;
    Lcd_Chr(2,5,48+ch);
    ch = (voltaje / 100 )% 10;
    Lcd_Chr_CP(48+ch);
    Lcd_Chr(2,7,'.');
    ch = (voltaje / 10 )% 10;
    Lcd_Chr(2,8,48+ch);
    ch = voltaje % 10;
    Lcd_Chr_CP(48+ch);
}
////////////////////////////////////////////////////////////////////////////////
void keypad() {
 short int i=0, select=0;
  RD0_bit=1;
  buzzer();
for(i=0; i<=3; i++){
   voltaje =(10*voltaje) + contador;
   if(voltaje>1630) voltaje=contador;
   volt=voltaje/0.398046; // vref=1.63 or aprox resolution = 1000*(Vref/4095)
   if(volt<22) volt=22;
   Voltage();
  do //wait that the keypad is pressed and after that is free.
  kp=Keypad_Key_Click();  //read the keypad.
  while (!kp);
     // keypad4x3
     if(kp==1)  contador = 1;
     if(kp==2)  contador = 2;
     if(kp==3)  contador = 3;
     if(kp==5)  contador = 4;
     if(kp==6)  contador = 5;
     if(kp==7)  contador = 6;
     if(Kp==9)  contador = 7;
     if(kp==10) contador = 8;
     if(kp==11) contador = 9;
     if(kp==13) contador = 0, voltaje=0, i=0; //clear(*)
     if(kp==14) contador = 0;
     if(kp==15) contador = 0, select=1; //Enter(#)
     kp=0;
     if((select==0)&&(i==3)) i=0;
     if(select==1) i=3;
     buzzer();
   }
}
////////////////////////////////////////////////////////////////////////////////
void main() {
  Set_up();   // Perform main initialization
  keypad();
///////////////////////////////////LOOP/////////////////////////////////////////
 while (1) { 
     RD0_bit=0;
     if(Keypad_Key_press()) delay_ms(100), voltaje=0, keypad();
     // reduce the voltage peaks
     for(retardo=retardo; retardo<=volt; retardo++){
     DAC_Output(retardo);                   // Send value to DAC chip
     Delay_ms(20);                         // Slow down key repeat pace
     }
     for(retardo=retardo; retardo>=volt; retardo--){
     DAC_Output(retardo);                   // Send value to DAC chip
     Delay_ms(20);                         // Slow down key repeat pace
     }
   }
  }
/////////////////////////////////END_LOOP///////////////////////////////////////